<template>
  <div
    ref="selfRef" class="item-container"
    @focusin="selfFocusEnter(mobile)"
    @mouseenter="selfFocusEnter(mobile)"
    @mouseleave="selfFocusLeave"
    @keydown.tab="()=> { if (isFocused && etat === 'DEFAULT') {
        this.isFocused = false
    }}"
  >
    <v-slide-x-transition v-show="loaded && etat !== 'EDIT'">
      <div>
        <v-card
          flat
          variant="elevated"
          :elevation="isFocused ? 6: 1"
          @click="handleItemClick(mobile)"
          :loading="loading"
          class="minimal-item-container"
          :color="
          isFocused ? (checked ? 'success' : 'primary') : 'surface-lighten-1'"
        >
          <div class="checkbox-container" v-if="$slots.checkbox" >
            <slot name="checkbox" :color="!isFocused && checked ? 'success': ''"></slot>
          </div>
          <v-card-title
            class="align-self-center text-wrap title"
            :class="(!isFocused && checked ? 'text-success ': '' + isFocused ? 'title-focused': '')"
          >{{ label }}</v-card-title>
          <v-slide-x-reverse-transition>
            <v-card-title v-if="isFocused && !mobile && etat === 'DEFAULT'" class="item-actions pr-0">
              <v-fab
                size="small"
                color="success"
                icon="mdi-pencil"
                @click.stop="enterEditMode()"
              ></v-fab>
              <v-fab
                size="small"
                color="error"
                icon="mdi-delete"
                @click.stop="enterDeleteMode()"
              ></v-fab>
            </v-card-title>
          </v-slide-x-reverse-transition>
        </v-card>
      </div>
    </v-slide-x-transition>
    <div class="item-complement-container">
      <v-expand-transition>
        <div class="mt-2" v-show="showComplement">
          <slot name="mobileComplement" v-if="mobile"></slot>
          <slot name="complement"></slot>
        </div>
      </v-expand-transition>
      <v-expand-transition hide-on-leave>
        <v-card variant="outlined" color="success" v-show="etat === 'EDIT'" class="my-2 w-100">
          <v-form
            @submit.prevent="updateItem()"
            @keyup="()=> {}"
          >
            <slot name="edit"></slot>
            <v-card-actions>
              <v-btn variant="tonal" color="info" type="submit">Confirm</v-btn>
              <v-btn variant="tonal" color="grey" @click="teardownEdit()">Abort</v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </v-expand-transition>
      <v-expand-transition hide-on-leave>
      <v-card v-show="etat === 'DELETE'" variant="outlined" color="error" class="my-2">
        <v-card-title>
          Confirm item deletion
        </v-card-title>
        <v-card-actions>
          <v-btn
            ref="confirmDeleteBtn"
            variant="tonal"
            color="error"
            @click="deleteItem"
          >Confirm</v-btn>
          <v-btn
            variant="tonal"
            color="grey"
            @click="teardownDelete()"
          >Abort</v-btn>
        </v-card-actions>
      </v-card>
      </v-expand-transition>
    </div>
    <v-slide-y-transition hide-on-leave>
      <v-btn-group v-show="isFocused && etat === 'DEFAULT'" class="add-btn-container pt-2">
        <v-btn
          @click.stop="$emit('setup-create')"
          variant="tonal"
          color="success"
        ><v-icon>mdi-plus</v-icon></v-btn>
        <v-btn
          v-if="mobile"
          variant="tonal"
          color="info"
          @click.stop="enterEditMode()"
        ><v-icon>mdi-pencil</v-icon></v-btn>
        <v-btn
          v-if="mobile"
          variant="tonal"
          color="error"
          @click.stop="enterDeleteMode()"
        ><v-icon>mdi-delete</v-icon></v-btn>
      </v-btn-group>
    </v-slide-y-transition>
  </div>
</template>

<script setup>
import { useDisplay } from 'vuetify'

const { mobile } = useDisplay()
</script>
<script>
import { useCollectionsStore } from '@/stores/itemCollections.js'
import { useKeypress } from 'vue3-keypress'
export default {
  name: "ck-base-item",
  data() {
    return {
      etat: 'DEFAULT',
      isFocused: false,
      loaded: false,
      apparitionDelay: 200,
    }
  },
  props: {
    itemId: {
      type: String,
      required: true
    },
    label: {
      type: String,
      default: ""
    },
    focusOnMount:  {
      type: Boolean,
      default: false
    },
    loading:  {
      type: Boolean,
      default: false
    },
    apparitionOrder:  {
      type: Number,
      default: 0
    },
    collectionId:  {
      type: String,
      required: true
    },
    checked: {
      type: Boolean,
      required: true
    }
  },
  computed: {
    showComplement() {
      return this.etat === 'DEFAULT' && this.isFocused
    }
  },
  methods: {
    selfFocusEnter(mobile) {
      if (this.etat === 'DEFAULT' && !mobile) {
        this.$refs.selfRef.focus()
        this.isFocused = true
      }
    },
    selfFocusLeave() {
      if (this.etat === 'DEFAULT') {
        this.$refs.selfRef.blur()
        this.isFocused = false
      }
    },
    switchFocus() {
      if (this.isFocused) {
        this.$refs.selfRef.blur()
        this.isFocused = false
      } else {
        this.$refs.selfRef.focus()
        this.isFocused = true
      }
    },
    handleItemClick(mobile) {
      if (mobile) {
        this.switchFocus()
      } else {
        if (this.etat === 'DEFAULT') {
          this.$emit('clicked')
        }
      }
    },
    enterEditMode() {
      this.etat = 'EDIT'
      this.$emit('setup-edit')
    },
    teardownEdit() {
      this.$emit('teardown-edit')
      this.$nextTick(() => {
        this.etat = 'DEFAULT'
        this.selfFocusEnter()
      });
    },
    enterDeleteMode() {
      this.$emit('delete')
      this.etat = 'DELETE'
      this.$nextTick(() => {
        this.$refs.confirmDeleteBtn.$el.focus()
      });
    },
    teardownDelete() {
      this.selfFocusEnter()
      this.$nextTick(() => {
        this.etat = 'DEFAULT'
      });
    },
    updateItem() {
      this.$emit('item-update')
      this.$nextTick(() => {
        this.selfFocusEnter()
        this.etat = 'DEFAULT'
      });
    },
    deleteItem() {
      useCollectionsStore().removeItem(this.collectionId, this.itemId)
      this.teardownDelete()
    },
  },
  mounted() {
    if (this.focusOnMount) {
      this.selfFocusEnter()
    }
    setTimeout(() => { this.loaded = true; }, this.apparitionDelay * this.apparitionOrder);
  },
  created() {
    useKeypress({
      keyEvent: "keyup",
      keyBinds: [
        {
          keyCode: 32, // Space key
          success: () => { if (this.isFocused && this.etat === 'DEFAULT')
            this.$emit('clicked')
          },
          preventDefault: true
        },
        {
          keyCode: 69, // 'e'
          success: () => {if (this.isFocused && this.etat === 'DEFAULT') this.enterEditMode()},
          preventDefault: true
        },
        {
          keyCode: 27, // Escape key
          success: () => {
            if (this.isFocused) {
              if (this.etat === "EDIT") this.teardownEdit()
              if (this.etat === "DELETE") this.teardownDelete()
            }
          },
          preventDefault: true
        },
        {
          keyCode: 46, // Delete key
          success: () => {if (this.isFocused && this.etat === 'DEFAULT') this.enterDeleteMode()},
          preventDefault: true
        },
        {
          keyCode: 65, // 'a'
          success: () => {if (this.isFocused && this.etat === 'DEFAULT') {
            if (this.etat === 'EDIT') this.teardownEdit()
            if (this.etat === 'DELETE') this.teardownDelete()
          }},
          preventDefault: true
        },
        {
          keyCode: 68, // 'd'
          success: () => {if (this.isFocused && this.etat === 'DEFAULT') this.enterDeleteMode()},
          preventDefault: true
        },
        {
          keyCode: 78, // 'n'
          success: () => {if (this.isFocused  && this.etat === 'DEFAULT') this.$emit('setup-create')},
          preventDefault: true
        },

      ]
    })
  },

}
</script>

<style scoped>
.item-container {
  outline: none;
  padding: 2px 0;
}
.minimal-item-container {
  display: flex;
  align-content: center;
}
.add-btn-container {
  display: flex;
  align-content: center;
  justify-content: center;
}
.checkbox-container {
  min-height: 52px;
  min-width: 48px;
  display: flex;
  align-items: center;
  justify-content: center;
}

@media (max-width: 600px) {
  .title {
    max-width: 88%;
  }
}

@media (min-width: 601px) {
  .title {
    max-width: 94%;
  }
}

.item-actions {
  position: absolute;
  right: 0;
  height: 100%;
  width: 128px;
  display: flex;
  justify-content: center;
  align-content: center;
}

</style>